# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib2 import urlopen, Request
except ImportError:
	from urllib.request import urlopen, Request
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import json, re, time
from collections import OrderedDict

def httpget(url):
	try:
		request = Request(
			url,
			headers = {
				'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36'
			})
		return urlopen(request).read().decode('utf-8')
	except:
		return False

def item(title, para, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	if 'title' not in para:
		para['title'] = title
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
	item('央视台', {'category': 'cctv'})
	item('卫视台', {'category': 'wstv'})
	item('港澳台', {'category': 'gatv'})
	item('体育直播', {'category': 'sports'})
	xbmcplugin.endOfDirectory(handle)
else:
	o = urlparse(url)
	q = parse_qs(o.query)
	if 'category' in q:
		category = q['category'][0]
		if category == 'sports':
			url = 'http://sports.localau.com/'
			content = httpget(url)
			if not content:
				xbmcgui.Dialog().ok('错误', '错误代码: localau 000')
				sys.exit(0)
			for e1 in re.findall('<li\s+[^>]*?class="[^"]*?gamelist[^"]*?"[^>]*?>\s*(.*?)\s*</li>', content, re.DOTALL|re.IGNORECASE):
				title = []
				for e2 in re.findall('<(span|div)+[^>]*?>\s*([^<>]*?)\s*</(span|div)>', e1, re.DOTALL|re.IGNORECASE):
					title += [e2[1]]
				e2 = re.search('<a\s+[^>]*?href="([^"]*?)"[^>]*?>', e1, re.DOTALL|re.IGNORECASE)
				if e2:
					title = ' '.join(title)
					item(title, {'title': title.encode('utf-8'), 'id': e2.group(1)})
		if category == 'cctv':
			item('CCTV-1综合', {'tv': 'cctv1'}, False)
			item('CCTV-2财经', {'tv': 'cctv2'}, False)
			item('CCTV-3综艺', {'tv': 'cctv3'}, False)
			item('CCTV-4中文国际', {'tv': 'cctv4'}, False)
			item('CCTV-5体育', {'tv': 'cctv5'}, False)
			item('CCTV-5+体育赛事', {'tv': 'c5plus'}, False)
			item('CCTV-6电影', {'tv': 'cctv6'}, False)
			item('CCTV-7军事', {'tv': 'cctv7'}, False)
			item('CCTV-8电视剧', {'tv': 'cctv8'}, False)
			item('CCTV-9纪录', {'tv': 'cctv9'}, False)
			item('CCTV-10科教', {'tv': 'cctv10'}, False)
			item('CCTV-11戏曲', {'tv': 'cctv11'}, False)
			item('CCTV-12法制', {'tv': 'cctv12'}, False)
			item('CCTV-13新闻', {'tv': 'cctv13'}, False)
			item('CCTV-14少儿', {'tv': 'cctv14'}, False)
			item('CCTV-15音乐', {'tv': 'cctv15'}, False)
		if category == 'wstv':
			item('北京卫视', {'tv': 'beijingHD'}, False)
			item('浙江卫视', {'tv': 'zhejiangHD'}, False)
			item('湖南卫视', {'tv': 'hunanHD'}, False)
			item('东方卫视', {'tv': 'dongfanghd'}, False)
			item('江苏卫视', {'tv': 'jiangsuhd'}, False)
			item('厦门卫视', {'tv': 'xmtv'}, False)
		if category == 'gatv':
			item('凤凰香港台', {'tv': 'fhxg'}, False)
			item('凤凰中文台', {'tv': 'fhzw'}, False)
			item('凤凰资讯台', {'tv': 'fhzx'}, False)
		xbmcplugin.endOfDirectory(handle)
	if 'tv' in q:
		tv = q['tv'][0]
		play('', 'http://live.centerch.com/%s.m3u8' % tv)
	if 'id' in q:
		id = q['id'][0]
		url = 'http://sports.localau.com' + id
		content = httpget(url)
		for e1 in re.findall('<a\s+[^>]*?href="([^"]*?)"[^>]*?>\s*([^<>]*?)\s*</a>', content, re.DOTALL|re.IGNORECASE):
			title = e1[1]
			url2 = e1[0]
			if url2[:26] == 'http://sports.localau.com/':
				item(title, {'title': title.encode('utf-8'), 'url2': url2}, False)
		xbmcplugin.endOfDirectory(handle)
	if 'url2' in q:
		url2 = q['url2'][0]
		content = httpget(url2)
		if not content:
			xbmcgui.Dialog().ok('错误', '错误代码: localau 020')
			sys.exit(0)
		m = re.search('<iframe\s+[^>]*?src="http://sports.localau.com/play.html\?id=([^"]*?)"[^>]*?>', content)
		if not m:
			xbmcgui.Dialog().ok('错误', '错误代码: localau 021')
			sys.exit(0)
		play(q['title'][0], 'http://live.centerch.com/%s.m3u8' % m.group(1))
